// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_controllers_msgs:msg/ControllerState.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__CONTROLLER_STATE__TRAITS_HPP_
#define ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__CONTROLLER_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_controllers_msgs/msg/detail/controller_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace robot_controllers_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ControllerState & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: state
  {
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ControllerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ControllerState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace robot_controllers_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_controllers_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_controllers_msgs::msg::ControllerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_controllers_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_controllers_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const robot_controllers_msgs::msg::ControllerState & msg)
{
  return robot_controllers_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<robot_controllers_msgs::msg::ControllerState>()
{
  return "robot_controllers_msgs::msg::ControllerState";
}

template<>
inline const char * name<robot_controllers_msgs::msg::ControllerState>()
{
  return "robot_controllers_msgs/msg/ControllerState";
}

template<>
struct has_fixed_size<robot_controllers_msgs::msg::ControllerState>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_controllers_msgs::msg::ControllerState>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_controllers_msgs::msg::ControllerState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__CONTROLLER_STATE__TRAITS_HPP_
