// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_controllers_msgs:msg/DiffDriveLimiterParams.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__TRAITS_HPP_
#define ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_controllers_msgs/msg/detail/diff_drive_limiter_params__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace robot_controllers_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DiffDriveLimiterParams & msg,
  std::ostream & out)
{
  out << "{";
  // member: max_linear_velocity
  {
    out << "max_linear_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_linear_velocity, out);
    out << ", ";
  }

  // member: max_linear_acceleration
  {
    out << "max_linear_acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.max_linear_acceleration, out);
    out << ", ";
  }

  // member: max_angular_velocity
  {
    out << "max_angular_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_angular_velocity, out);
    out << ", ";
  }

  // member: max_angular_acceleration
  {
    out << "max_angular_acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.max_angular_acceleration, out);
    out << ", ";
  }

  // member: max_wheel_velocity
  {
    out << "max_wheel_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_wheel_velocity, out);
    out << ", ";
  }

  // member: track_width
  {
    out << "track_width: ";
    rosidl_generator_traits::value_to_yaml(msg.track_width, out);
    out << ", ";
  }

  // member: angular_velocity_limits_linear_velocity
  {
    out << "angular_velocity_limits_linear_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.angular_velocity_limits_linear_velocity, out);
    out << ", ";
  }

  // member: scale_to_wheel_velocity_limits
  {
    out << "scale_to_wheel_velocity_limits: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_to_wheel_velocity_limits, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DiffDriveLimiterParams & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: max_linear_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_linear_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_linear_velocity, out);
    out << "\n";
  }

  // member: max_linear_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_linear_acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.max_linear_acceleration, out);
    out << "\n";
  }

  // member: max_angular_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_angular_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_angular_velocity, out);
    out << "\n";
  }

  // member: max_angular_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_angular_acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.max_angular_acceleration, out);
    out << "\n";
  }

  // member: max_wheel_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_wheel_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.max_wheel_velocity, out);
    out << "\n";
  }

  // member: track_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "track_width: ";
    rosidl_generator_traits::value_to_yaml(msg.track_width, out);
    out << "\n";
  }

  // member: angular_velocity_limits_linear_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angular_velocity_limits_linear_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.angular_velocity_limits_linear_velocity, out);
    out << "\n";
  }

  // member: scale_to_wheel_velocity_limits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scale_to_wheel_velocity_limits: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_to_wheel_velocity_limits, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DiffDriveLimiterParams & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace robot_controllers_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_controllers_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_controllers_msgs::msg::DiffDriveLimiterParams & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_controllers_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_controllers_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const robot_controllers_msgs::msg::DiffDriveLimiterParams & msg)
{
  return robot_controllers_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<robot_controllers_msgs::msg::DiffDriveLimiterParams>()
{
  return "robot_controllers_msgs::msg::DiffDriveLimiterParams";
}

template<>
inline const char * name<robot_controllers_msgs::msg::DiffDriveLimiterParams>()
{
  return "robot_controllers_msgs/msg/DiffDriveLimiterParams";
}

template<>
struct has_fixed_size<robot_controllers_msgs::msg::DiffDriveLimiterParams>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<robot_controllers_msgs::msg::DiffDriveLimiterParams>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<robot_controllers_msgs::msg::DiffDriveLimiterParams>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__TRAITS_HPP_
