// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robot_controllers_msgs:srv/QueryControllerStates.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__STRUCT_H_
#define ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'updates'
#include "robot_controllers_msgs/msg/detail/controller_state__struct.h"

/// Struct defined in srv/QueryControllerStates in the package robot_controllers_msgs.
typedef struct robot_controllers_msgs__srv__QueryControllerStates_Request
{
  /// Requested changes to controller state. Each state must
  /// have at least the controller name and new state. If the
  /// controller type is non-empty, then it will be used to
  /// make sure that the controller type matches.
  robot_controllers_msgs__msg__ControllerState__Sequence updates;
} robot_controllers_msgs__srv__QueryControllerStates_Request;

// Struct for a sequence of robot_controllers_msgs__srv__QueryControllerStates_Request.
typedef struct robot_controllers_msgs__srv__QueryControllerStates_Request__Sequence
{
  robot_controllers_msgs__srv__QueryControllerStates_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_controllers_msgs__srv__QueryControllerStates_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'state'
// already included above
// #include "robot_controllers_msgs/msg/detail/controller_state__struct.h"

/// Struct defined in srv/QueryControllerStates in the package robot_controllers_msgs.
typedef struct robot_controllers_msgs__srv__QueryControllerStates_Response
{
  robot_controllers_msgs__msg__ControllerState__Sequence state;
} robot_controllers_msgs__srv__QueryControllerStates_Response;

// Struct for a sequence of robot_controllers_msgs__srv__QueryControllerStates_Response.
typedef struct robot_controllers_msgs__srv__QueryControllerStates_Response__Sequence
{
  robot_controllers_msgs__srv__QueryControllerStates_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_controllers_msgs__srv__QueryControllerStates_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__STRUCT_H_
