// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_controllers_msgs:msg/DiffDriveLimiterParams.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_HPP_
#define ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__robot_controllers_msgs__msg__DiffDriveLimiterParams __attribute__((deprecated))
#else
# define DEPRECATED__robot_controllers_msgs__msg__DiffDriveLimiterParams __declspec(deprecated)
#endif

namespace robot_controllers_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DiffDriveLimiterParams_
{
  using Type = DiffDriveLimiterParams_<ContainerAllocator>;

  explicit DiffDriveLimiterParams_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_linear_velocity = 0.0;
      this->max_linear_acceleration = 0.0;
      this->max_angular_velocity = 0.0;
      this->max_angular_acceleration = 0.0;
      this->max_wheel_velocity = 0.0;
      this->track_width = 0.0;
      this->angular_velocity_limits_linear_velocity = false;
      this->scale_to_wheel_velocity_limits = false;
    }
  }

  explicit DiffDriveLimiterParams_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_linear_velocity = 0.0;
      this->max_linear_acceleration = 0.0;
      this->max_angular_velocity = 0.0;
      this->max_angular_acceleration = 0.0;
      this->max_wheel_velocity = 0.0;
      this->track_width = 0.0;
      this->angular_velocity_limits_linear_velocity = false;
      this->scale_to_wheel_velocity_limits = false;
    }
  }

  // field types and members
  using _max_linear_velocity_type =
    double;
  _max_linear_velocity_type max_linear_velocity;
  using _max_linear_acceleration_type =
    double;
  _max_linear_acceleration_type max_linear_acceleration;
  using _max_angular_velocity_type =
    double;
  _max_angular_velocity_type max_angular_velocity;
  using _max_angular_acceleration_type =
    double;
  _max_angular_acceleration_type max_angular_acceleration;
  using _max_wheel_velocity_type =
    double;
  _max_wheel_velocity_type max_wheel_velocity;
  using _track_width_type =
    double;
  _track_width_type track_width;
  using _angular_velocity_limits_linear_velocity_type =
    bool;
  _angular_velocity_limits_linear_velocity_type angular_velocity_limits_linear_velocity;
  using _scale_to_wheel_velocity_limits_type =
    bool;
  _scale_to_wheel_velocity_limits_type scale_to_wheel_velocity_limits;

  // setters for named parameter idiom
  Type & set__max_linear_velocity(
    const double & _arg)
  {
    this->max_linear_velocity = _arg;
    return *this;
  }
  Type & set__max_linear_acceleration(
    const double & _arg)
  {
    this->max_linear_acceleration = _arg;
    return *this;
  }
  Type & set__max_angular_velocity(
    const double & _arg)
  {
    this->max_angular_velocity = _arg;
    return *this;
  }
  Type & set__max_angular_acceleration(
    const double & _arg)
  {
    this->max_angular_acceleration = _arg;
    return *this;
  }
  Type & set__max_wheel_velocity(
    const double & _arg)
  {
    this->max_wheel_velocity = _arg;
    return *this;
  }
  Type & set__track_width(
    const double & _arg)
  {
    this->track_width = _arg;
    return *this;
  }
  Type & set__angular_velocity_limits_linear_velocity(
    const bool & _arg)
  {
    this->angular_velocity_limits_linear_velocity = _arg;
    return *this;
  }
  Type & set__scale_to_wheel_velocity_limits(
    const bool & _arg)
  {
    this->scale_to_wheel_velocity_limits = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_controllers_msgs__msg__DiffDriveLimiterParams
    std::shared_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_controllers_msgs__msg__DiffDriveLimiterParams
    std::shared_ptr<robot_controllers_msgs::msg::DiffDriveLimiterParams_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DiffDriveLimiterParams_ & other) const
  {
    if (this->max_linear_velocity != other.max_linear_velocity) {
      return false;
    }
    if (this->max_linear_acceleration != other.max_linear_acceleration) {
      return false;
    }
    if (this->max_angular_velocity != other.max_angular_velocity) {
      return false;
    }
    if (this->max_angular_acceleration != other.max_angular_acceleration) {
      return false;
    }
    if (this->max_wheel_velocity != other.max_wheel_velocity) {
      return false;
    }
    if (this->track_width != other.track_width) {
      return false;
    }
    if (this->angular_velocity_limits_linear_velocity != other.angular_velocity_limits_linear_velocity) {
      return false;
    }
    if (this->scale_to_wheel_velocity_limits != other.scale_to_wheel_velocity_limits) {
      return false;
    }
    return true;
  }
  bool operator!=(const DiffDriveLimiterParams_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DiffDriveLimiterParams_

// alias to use template instance with default allocator
using DiffDriveLimiterParams =
  robot_controllers_msgs::msg::DiffDriveLimiterParams_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robot_controllers_msgs

#endif  // ROBOT_CONTROLLERS_MSGS__MSG__DETAIL__DIFF_DRIVE_LIMITER_PARAMS__STRUCT_HPP_
