// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_controllers_msgs:srv/QueryControllerStates.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__TRAITS_HPP_
#define ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_controllers_msgs/srv/detail/query_controller_states__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'updates'
#include "robot_controllers_msgs/msg/detail/controller_state__traits.hpp"

namespace robot_controllers_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const QueryControllerStates_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: updates
  {
    if (msg.updates.size() == 0) {
      out << "updates: []";
    } else {
      out << "updates: [";
      size_t pending_items = msg.updates.size();
      for (auto item : msg.updates) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const QueryControllerStates_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: updates
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.updates.size() == 0) {
      out << "updates: []\n";
    } else {
      out << "updates:\n";
      for (auto item : msg.updates) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const QueryControllerStates_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace robot_controllers_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_controllers_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_controllers_msgs::srv::QueryControllerStates_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_controllers_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_controllers_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const robot_controllers_msgs::srv::QueryControllerStates_Request & msg)
{
  return robot_controllers_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<robot_controllers_msgs::srv::QueryControllerStates_Request>()
{
  return "robot_controllers_msgs::srv::QueryControllerStates_Request";
}

template<>
inline const char * name<robot_controllers_msgs::srv::QueryControllerStates_Request>()
{
  return "robot_controllers_msgs/srv/QueryControllerStates_Request";
}

template<>
struct has_fixed_size<robot_controllers_msgs::srv::QueryControllerStates_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_controllers_msgs::srv::QueryControllerStates_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_controllers_msgs::srv::QueryControllerStates_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'state'
// already included above
// #include "robot_controllers_msgs/msg/detail/controller_state__traits.hpp"

namespace robot_controllers_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const QueryControllerStates_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: state
  {
    if (msg.state.size() == 0) {
      out << "state: []";
    } else {
      out << "state: [";
      size_t pending_items = msg.state.size();
      for (auto item : msg.state) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const QueryControllerStates_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.state.size() == 0) {
      out << "state: []\n";
    } else {
      out << "state:\n";
      for (auto item : msg.state) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const QueryControllerStates_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace robot_controllers_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_controllers_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_controllers_msgs::srv::QueryControllerStates_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_controllers_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_controllers_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const robot_controllers_msgs::srv::QueryControllerStates_Response & msg)
{
  return robot_controllers_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<robot_controllers_msgs::srv::QueryControllerStates_Response>()
{
  return "robot_controllers_msgs::srv::QueryControllerStates_Response";
}

template<>
inline const char * name<robot_controllers_msgs::srv::QueryControllerStates_Response>()
{
  return "robot_controllers_msgs/srv/QueryControllerStates_Response";
}

template<>
struct has_fixed_size<robot_controllers_msgs::srv::QueryControllerStates_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_controllers_msgs::srv::QueryControllerStates_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_controllers_msgs::srv::QueryControllerStates_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<robot_controllers_msgs::srv::QueryControllerStates>()
{
  return "robot_controllers_msgs::srv::QueryControllerStates";
}

template<>
inline const char * name<robot_controllers_msgs::srv::QueryControllerStates>()
{
  return "robot_controllers_msgs/srv/QueryControllerStates";
}

template<>
struct has_fixed_size<robot_controllers_msgs::srv::QueryControllerStates>
  : std::integral_constant<
    bool,
    has_fixed_size<robot_controllers_msgs::srv::QueryControllerStates_Request>::value &&
    has_fixed_size<robot_controllers_msgs::srv::QueryControllerStates_Response>::value
  >
{
};

template<>
struct has_bounded_size<robot_controllers_msgs::srv::QueryControllerStates>
  : std::integral_constant<
    bool,
    has_bounded_size<robot_controllers_msgs::srv::QueryControllerStates_Request>::value &&
    has_bounded_size<robot_controllers_msgs::srv::QueryControllerStates_Response>::value
  >
{
};

template<>
struct is_service<robot_controllers_msgs::srv::QueryControllerStates>
  : std::true_type
{
};

template<>
struct is_service_request<robot_controllers_msgs::srv::QueryControllerStates_Request>
  : std::true_type
{
};

template<>
struct is_service_response<robot_controllers_msgs::srv::QueryControllerStates_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CONTROLLERS_MSGS__SRV__DETAIL__QUERY_CONTROLLER_STATES__TRAITS_HPP_
